<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for moo.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
moo - analyze SUIF program for privatizable scalar variables.

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>moo</B> <B>-Psce</B> <I>infile</I> <I>outfile</I>

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
The <I>moo</I> program reads in a SUIF file one procedure at a
time, attaching to each for-loop an annotation that indicates
the privatizable scalar variables of the loop. A
variable is privatizable if every iteration of the forloop
can have its own copy of the variable. The annotated
SUIF program is written out into <I>outfile</I>.
<P>
<I>Moo</I> considers a scalar variable as privatizable if the
variable is read or written in the loop and there are no
upward exposed read of the variable at the entry of the
loop body, and if no definition of the variable in the
loop reaches a use outside of the loop. For example, in
the following program fragment:
<P>
<B>do</B> <B>100</B> <B>i=1,10</B><BR>

<B>p</B> <B>=</B> <A HREF="man_f.np.html">f(np)</A>
<BR>

<B>100</B> <B>np</B> <B>=</B> <A HREF="man_g.p.html">g(p)</A>

<P>
the variable <I>p</I> is privatizable while the variable <I>np</I> is
not. In the SUIF excerpt from moo's output of the above
fragment, there are three kinds of annotations: one indicates
that i, np, and p are read in the loop, one indicates
that i, np, and p are written, and one that indicates
i, and p are privatizable.
<P>
<B>2:</B> <B>FOR</B> <B>(Index=MAIN__.i</B> <B>Test=SLTE</B> <B>Cont=L:MAIN__.L1</B> <B>Brk=L:MAIN__.L2)</B>
<B>["read</B> <B>vars":</B> <B>&lt;MAIN__.i,0&gt;</B> <B>&lt;MAIN__.np,0&gt;</B> <B>&lt;MAIN__.p,0&gt;]</B>
<B>["write</B> <B>vars":</B> <B>&lt;MAIN__.i,0&gt;</B> <B>&lt;MAIN__.np,0&gt;</B> <B>&lt;MAIN__.p,0&gt;]</B>
<B>["privatizable":</B> <B>&lt;MAIN__.i,0&gt;</B> <B>&lt;MAIN__.p,0&gt;]</B>

<H2><A NAME="sect3" HREF="#toc3"><B>Options</B></A></H2>

<P>
<I>Moo</I> accepts exactly one flag <B>-Psce</B>. Every time you invoke
<I>moo</I>, you must include this flag. <I>Moo</I> has been designed to
serve as the basis for a new scalar optimizer to replace
oynk. If and when that happens, <I>moo</I> will accept other
flags.

<H2><A NAME="sect4" HREF="#toc4"><B>See</B> <B>Also</B></A></H2>

<P>
<A HREF="man_oynk.1.html">oynk(1)</A>

<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">Options</A></LI>
<LI><A NAME="toc4" HREF="#sect4">See Also</A></LI>
</UL>
</BODY></HTML>
